#include <Types.h>
#include <StdIO.h>

#define numRdArgs	2		/* Number of arguments for read command.	*/
#define numWrArgs	3		/* Number of arguments for write command.	*/

#define kCommandArg 0
#define kAddrArg 1
#define kDataArg 2

typedef unsigned long ulong ;
typedef unsigned char ubyte ;

//
// Main()
//
unsigned main(ulong argC, char *argV[])

{	
	ulong	status = noErr;

	if ((argC >= 2) && (argC <= 3))
	{	
		ubyte *address;
	
		sscanf(argV[kAddrArg],"%i", &address);
		
		if(true /*IN_RANGE(address, VBLInt, CurLine)*/)
		{	
			ubyte writeValue, readValue ;
			ulong longWriteValue ;
		
			switch(argC)
			{	
			case numRdArgs:
				readValue = *address ;
				
				fprintf(stdout,"$%p -> $%02X (%d)\n",
						address, readValue, readValue);
			break;
			
			case numWrArgs:
				sscanf(argV[kDataArg], "%i", &longWriteValue);
				writeValue = longWriteValue ;
				*address = writeValue ;
				fprintf(stdout,"$%p <- $%02X (%d)\n",
						address, writeValue, writeValue);
			break;
			
			default:
				status++;
			break;
			}
		}
		else
			status++;
		}
	else
		status++;

	if (status != noErr)
		fprintf(stdout,"# Usage %s - address [value].\n", argV[kCommandArg]);

	return(status);
	}
