/*============================================================
	ShowStackChain.h
	
	greggor@apple.com
============================================================*/
#ifndef __SHOWSTACKCHAIN__
#define __SHOWSTACKCHAIN__

#define kMaxStackChainEntries	40

struct StackChainInfo
{
	short					fEntries;
	void*					fReturnAddress[kMaxStackChainEntries];
};

typedef struct StackChainInfo StackChainInfo;

void						RecordStackChain( StackChainInfo* stackChainInfo );
void						ShowStackChain( Str255 title, StackChainInfo* stackChainInfo );

void						RecordFailureStackChain(void);
void						ShowFailureStackChain(Str255 title);
void						InitShowStackChain(void);

#endif
