/*------------------------------------------------------------------------------
#
#	TV-Man.Menus.r	-	Rez Source
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#	Version:	1.00
#
#
#	This file contains all of the Menu resource data
#
#	Revision Log:
#	
#		11-05-91	RGK		Added the menu items for single color screens
#		04-26-91	RGK		Creation
#
#
------------------------------------------------------------------------------*/


/*	this will eliminate non Rez statements from the header files	*/

#define	__Rezing__			


/*	Now lets include all of the neecessary files.	*/

#include "TV-Man.h"
#include "SysTypes.r"
#include "Types.r"

#include "TV-Man.Menus.h"



/*-------------------------------------------------------------------------------*/
/*	we use an MBAR resource to conveniently load all the menus */

resource 'MBAR' (rMenu, preload)
{
	{
		mApple, mFile, mEdit, mPatterns, mBeeps
	};
};




/*-------------------------------------------------------------------------------*/

resource 'MENU' (mApple, preload)
{
	mApple, textMenuProc, AllItems & ~MenuItem2, enabled, apple,
	{
		"About TV-Man", noicon, nokey, nomark, plain;
		"-", noicon, nokey, nomark, plain
	}
};




/*-------------------------------------------------------------------------------*/

resource 'MENU' (mFile, preload)
{
	mFile, textMenuProc, MenuItem12, enabled, "File",
	{
		"New", noicon, "N", nomark, plain;
		"Open", noicon, "O", nomark, plain;
		"-", noicon, nokey, nomark, plain;
		"Close", noicon, "W", nomark, plain;
		"Save", noicon, "S", nomark, plain;
		"Save As", noicon, nokey, nomark, plain;
		"Revert", noicon, nokey, nomark, plain;
		"-", noicon, nokey, nomark, plain;
		"Page Setup", noicon, nokey, nomark, plain;
		"Print", noicon, nokey, nomark, plain;
		"-", noicon, nokey, nomark, plain;
		"Quit", noicon, "Q", nomark, plain
	}
};




/*-------------------------------------------------------------------------------*/

resource 'MENU' (mEdit, preload)
{
	mEdit, textMenuProc, NoItems, enabled, "Edit",
	{
		"Undo", noicon, "Z", nomark, plain;
		"-", noicon, nokey, nomark, plain;
		"Cut", noicon, "X", nomark, plain;
		"Copy", noicon, "C", nomark, plain;
		"Paste", noicon, "V", nomark, plain;
		"Clear", noicon, nokey, nomark, plain
	}
};





/*-------------------------------------------------------------------------------*/

resource 'MENU' (mPatterns, preload)
{
	mPatterns, textMenuProc, NoItems, enabled, "Video Patterns",
	{
	 	"Test Pattern", noicon, nokey, nomark, plain;
		"Color Bars", noicon, nokey, nomark, plain;
		"Gray Scale L>D", noicon, nokey, nomark, plain;
		"Gray Scale D>L", noicon, nokey, nomark, plain;
		"Vertical Lines", noicon, nokey, nomark, plain;
		"Horizontal Lines", noicon, nokey, nomark, plain;
		"Line Burst", noicon, nokey, nomark, plain;
		"Red Screen", noicon, nokey, nomark, plain;
		"Green Screen", noicon, nokey, nomark, plain;
		"Blue Screen", noicon, nokey, nomark, plain;
		"White Screen", noicon, nokey, nomark, plain;
	}
};





/*-------------------------------------------------------------------------------*/

resource 'MENU' (mBeeps, preload)
{
	mBeeps, textMenuProc, NoItems, enabled, "BeepMaster",
	{
		"Soprano Voice", noicon, "1", nomark, plain;
		"Alto Voice", noicon, "2", nomark, plain;
		"Tenor Voice", noicon, "3", nomark, plain;
		"Bass Voice", noicon, "4", nomark, plain;
		"-", noicon, nokey, nomark, plain;
		"Disable all Beeps", noicon, "D", nomark, plain;
		"Enable all Beeps", noicon, "E", nomark, plain
	}
};
